// file: ~kaldindi/work/class/ppm/ppm_constants.h
//
// this file defines global paths, filenames and constants of the ppm class
//

// make sure definitions are made only once
//
#ifndef __ISIP_PPM_CONSTANTS
#define __ISIP_PPM_CONSTANTS

// define the class name
//
#define PPM_CLASS_NAME (char_1*)"Ppm"

// define the magic number - we only accept P6 format, which
// uses three bytes per pixel, one byte for each color.
//
#define PPM_MAGIC_NUMBER (char_1*)"P6"
#define PPM_NBYTES_PER_PIXEL (int_4)3

// define information needed to process the header, such as comment fields
//
#define PPM_HEADER_NUM_LINES (int_4)3
#define PPM_HEADER_COMMENT_CHAR (char_1)'#'

// define the maximum color value
//
#define PPM_MAX_COLOR (int_4)255

// define header formats
//
#define PPM_HEADER_R0 (char_1*)"%s"
#define PPM_HEADER_R1 (char_1*)"%ld%ld"
#define PPM_HEADER_R2 (char_1*)"%ld"

#define PPM_HEADER_W (char_1*)"%s\n%ld %ld\n%ld\n"

// end of file
//
#endif
