// file: ~kaldindi/work/class/ppm/ppm_follow_cc
//

// isip include files
//
#include "ppm.h"
#include <math/integral.h>
#include <math/integral_constants.h>

// this method is used in the canny-edge detection for connecting the edges
//
logical_1 Ppm::follow_cc(int_2 i, int_2 j, int_2 low, int_4 cols, int_4 rows,
			 uint_1* data, uint_1* magnitude,
			 uint_1* orientation) {
  
  int k,l;        /* counters */
  int i_plus_1,i_minus_1,j_plus_1,j_minus_1;
  long index,kindex;
  char break_flag;
  
  i_plus_1=i+1;
  i_minus_1=i-1;
  j_plus_1=j+1;
  j_minus_1=j-1;
  index=i+j*cols;
  if (j_plus_1>=rows) j_plus_1=rows-1;
  if (j_minus_1<0) j_minus_1=0;
  if (i_plus_1>=cols) i_plus_1=cols-1;
  if (i_minus_1<0) i_minus_1=0;
  /*fprintf(stderr,"follow: i,j=%d %d, i_plus_1,i_minus_1=%d %d\n",i,j,i_plus_1,i_minus_1);*/
  if (!data[index])
    {
      /*fprintf(stderr,"following %d %d\n",i,j);*/
      /* current point must be added to the list of tracked points */
      data[index]=magnitude[index];
      /* now we can check immediately adjacent points to see if
	 they too could be added to the track */
      break_flag=0;
      for (k=i_minus_1;k<=i_plus_1;k++)
	{
	  for(l=j_minus_1;l<=j_plus_1;++l)
	    {
	      kindex=k+l*cols;
	      if (!(l==j && k==i) &&
		  magnitude[kindex]>=low &&
		  abs(abs(orientation[index]-orientation[kindex])-128)>180)
                {
		  if (follow_cc(k,l,low,cols,rows,data,magnitude,orientation))
                    {
		      break_flag=1;
		      break;
                    }
                }
	    }
	  if (break_flag) break;
        }
      return(1);
    }
  else return(0);
}
