// file: ~kaldindi/work/class/ppm/ppm_line_cc
//

// isip include files
//
#include "ppm.h"
#include <math/integral.h>
#include <math/integral_constants.h>

// method: ppm_line_cc
//
// arguments:
//  int_4 lines: (output)
//  uint_2* data: (input) data after edge detection
//  int_4 width: (input) width of the image
//  int_4 height: (input) height of the image
//  int_4* max_line: (output) maximum number of lines
//
// return: logical_1 value indicating the status
//
logical_1 Ppm::line_cc(int_4* lines, uint_2* data,
		       int_4 width, int_4 height, int_4* max_line) {
  
  // declare local variables
  //
  int_4 max_pixel = 0;
  
  for(int_2 i=0; i<height; i++) {
    for(int_2 j=0; j<width; j++) {
      
      int_4 pixel_num = 0;
      int_4 h_dev = 0;
      int_4 v_dev = 0;
      int_4 row = i;
      int_4 col = j;
      
      while (data[i*width+j]==255)
	{
	  data[i*width+j]=0;
	  pixel_num++;
	  
	  h_dev = col -j;
	  v_dev = 0;
	  
	  if (data[(i+1)*width+j]==255)
	    i++;
	  else
	    {
	      while (v_dev<=5 && data[(i+v_dev)*width+j] !=255)
		v_dev++;
	      if (v_dev<5)
		{
		  i=v_dev+i;
		  pixel_num=pixel_num+4;
		}
	      else
		if ((data[(i+1)*width+j+1]==255) && abs(h_dev)<2)
		  {
		    j++;
		    i++;
		    h_dev--;
		  }                    
		else
		  if ((data[(i+1)*width+j-1]==255) && abs(h_dev)<2)
		    {
		      j--;
		      i++;
		      h_dev++;
		    }   
	    }
	}
      
      if (pixel_num>=15)
	{
	  if (pixel_num > max_pixel)
	    max_pixel=pixel_num;
	  max_line[0] = max_line[0]+1;
	  lines[pixel_num]=lines[pixel_num]+1;
	}
      i=row;   /* restore the coordinator */
      j=col;
      
    }
  }
  
  /* print out the result */
  
  //fprintf(fpt2,"%d\n", MaxPixel);                      
  //for (i=10;i<=MaxPixel;i++)
  //if (Lines[i]!=0)
  //fprintf(stdout,"%d %d\n", i, lines[i]); 
  //fprintf(stdout,"%ld\n",line_num);

  // exit gracefully
  //
  return ISIP_TRUE;
  
}

