// file: ~kaldindi/work/class/ppm_hist_0.cc
//

// isip include files
//
#include "ppm.h"
#include <math/integral_constants.h>
#include "ppm_constants.h"

// method: hist_cc
//
// arguments:
//  uint_1* b_red_a: red buffer
//  uint_1* b_greeb_a: green buffer
//  uint1* b_blue_a: blue buffer
//  int_4 bsize: block size
//  int_4* redcount_a: buffer having the count of red values form 0 to 255
//  int_4* greencount_a: buffer having the count of green values form 0 to 255
//  int_4* bluecount_a: buffer having the count of blue values form 0 to 255
//
// return: a logical_value indicating the status
//
// this method computes the mean of each of the color in the image
//
logical_1 Ppm::mean_cc(uint_1* b_red_a, uint_1* b_green_a,
		       uint_1* b_blue_a, int_4 bsize,
		       int_4* redcount_a, int_4* greencount_a,
		       int_4* bluecount_a) {
  
  
  //  int_2* redcount = new int_2[256];
  //int_2* greencount = new int_2[256];
  //int_2* bluecount = new int_2[256];
  
  for (int_2 m = 0; m < bsize*bsize; m++) {
    int_2 red = b_red_a[m];
    int_2 green = b_green_a[m];
    int_2 blue = b_blue_a[m];
    
    redcount_a[red] = redcount_a[red] + 1;
    greencount_a[green] = greencount_a[green] + 1;
    bluecount_a[blue] = bluecount_a[blue] + 1;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}

