// file: ~kaldindi/work/class/ppm/ppm_thresholding_cc
//

// isip include files
//
#include "ppm.h"
#include <math/integral.h>
#include <math/integral_constants.h>

// this method is used in the canny-edge detector for thresholding
//
logical_1 Ppm::thresholding_cc(int_2 high, int_2 low, int_4 cols, int_4 rows,
			       uint_1* data, uint_1* magnitude,
			       uint_1* orientation) {

  
  int i,j;    /* counters */
  int picsize;    /* picture area */
  
  fprintf(stderr,"thresholding_tracker: tracking edges, high=%d, low=%d\n",
	  high,low);
  /* clear data array before tracking */
  picsize=cols*rows;
  for (i=0;i<picsize;++i) data[i]=0;
  
  /* threshold image with hysteresis: follow from
     each strong edge point */
  for (i=0;i<cols;++i)
      {
        for (j=0;j<rows;++j)
            if (magnitude[i+cols*j]>=high)
                follow_cc(i,j,low,cols,rows,data,magnitude,orientation);
      }

  // exit gracefully
  //
  return ISIP_TRUE;
}
  
  

